<?php
//------------------------------------------------------------------------------
//
// Arrays
//
//------------------------------------------------------------------------------
$a437=" ઀";
$a928="";
//------------------------------------------------------------------------------
$FontSize=array(0=>'Standard', 8=>8, 9=>9, 10=>10, 11=>11 , 12=>12 , 13=>13, 14=>14 );
//------------------------------------------------------------------------------
$KeepTime=array(1=>'1 day', 2=>'2 days', 5=>'5 days', 10=>'10 days', 20=>'20 days',
   30=>'1 month', 60=>'2 months', 0=>'For ever' );
//------------------------------------------------------------------------------
//
// Classes
//
//------------------------------------------------------------------------------
class cX2 extends cMOBILE
{
   /*
         extra variables,   extra functions.
   */
   var $pageName;
   var $pgsz;
   var $xptype;

	//...................................................
	function __construct(&$db)
	{
		parent::__construct($db);
		$this->useSession=true;
		$this->lpath='Unknown';
		$this->pageName='generic';
		$this->pgsz=15;
		$this->xptype=0; // on screen
	}
	//...................................................
	// cX2::
	function full_lpath()
	{
		if (strtoupper(PHP_OS)=='WINNT') {
         // We use strtr() for Apache on Windows
         $spath=strtr(dirname($_SERVER['PATH_TRANSLATED']),"/","\\");

         $l=strlen($spath);
         if ($l && $spath[$l-1]=='\\')
            $spath=substr($spath,0,$l-1);

         $endup=strrchr($spath,'\\');
         if ($endup=='\\ishop') {
            $f=$spath.'\\'.$this->lpath;
         }
         else {
            $f=dirname($spath);
            $l=strlen($f);
            if ($l && $f[$l-1]!='\\')
               $f.='\\';

            $f.='ishop\\'.$this->lpath;
         }
      }
      else { // unix
         $spath=$_SERVER['DOCUMENT_ROOT'];
         $l=strlen($spath);
         if ($l && $spath[$l-1]!='/')
            $spath.='/';
         $f=$spath.'ishop/'.$this->lpath;
      }

      return $f;
   }
	//...................................................
   // cX2::
   function confirm_login(&$errstr)
   {
      $db=&$this->db;

		if (($o2=confirm_pwd($db))===false)
			return false;

		$this->agentid=$o2->AGENTID;
		$this->isadmin=$o2->ISADMIN;
		$this->lpath=$o2->LPATH;
		$this->reselid=$o2->RESELID;
      
      $nowt=time();

      // Delete old sessions (1 hour old)
		$query="DELETE FROM ishop_session_ctl WHERE APPLI='BackOffice' AND $nowt - LASTUSAGE > 3600";
		if (!$db->Execute($query)) {
         $errstr=__LINE__.$db->ErrorMsg();
         return false;
      }

      // $ulogin=$this->agentid.'#'.$this->reselid;
      $t1='ishop_session_ctl';
      $prim=array('APPLI', 'SESSID');
      $data=array('APPLI'=>'BackOffice', 'AGENTID'=>$o2->AGENTID, 'ULOGIN'=>(string)$this->reselid, 'SESSID'=>session_id(), 'LASTUSAGE'=>$nowt );
      //if ($db->Replace($t1, $data, $prim, $autoQuote=true)==0) {
      if ($db->ReplaceEx($t1, $data, $prim)==0) {
         $errstr=__LINE__.$db->ErrorMsg();
         return false;
      }

      // 'TIDIFF'=>$tidiff :: client(bowser) = local(server) + tidiff
      $tidiff=0;
      if (isset($_REQUEST['CLIDATE'])) {
         $clidate=explode('-',$_REQUEST['CLIDATE']);
	      $clitime=explode(':',$_REQUEST['CLITIME']);
	      if (count($clidate)==3 && count($clitime)==3) {
            $cliti=mktime( $clitime[0], $clitime[1], $clitime[2], $clidate[1], $clidate[2], $clidate[0]);
	         $tidiff=$cliti-time(); // client(bowser) - local(server)
	      }   
	   }

		$data=array( 'AGENTID'=>$this->agentid, 'LPATH'=>$this->lpath, 'ISADMIN'=>$this->isadmin,
         'RESELID'=>$this->reselid, 'RE_NAME'=>$o2->RE_NAME, 'TIDIFF'=>$tidiff );
		$this->addArray($data);

		return true;
	}
	//...................................................
	// cX2::
	function short_login()
	{
   	$db=&$this->db;

	   $query="SELECT T2.LPATH, T1.AGENTID, T2.ISADMIN, T1.RESELID, RE_NAME FROM reseller T1
			INNER JOIN agents T2 ON (T2.AGENTID=T1.AGENTID)
			WHERE T1.RESELID=?";
	 	$data=array( (int)@$_REQUEST['RESELID'] );
		if (!($rs=$db->Execute($query,$data))) {
			echo "<h6>".$db->ErrorMsg()."</h6>\n";
			return false;
		}
		$o1=$rs->FetchNextObject();
		$rs->Close();
		if ($o1===false)
			return false;

	   $this->agentid=$o1->AGENTID;
		$this->isadmin=$o1->ISADMIN;
		$this->lpath=$o1->LPATH;
		$this->reselid=$o1->RESELID;

		return true;
	}
   //...................................................
	// cX2::
	function getOrderTotals(&$cot)
 	{
		// 'cot' is of type cORDERTOTAL
 		$dsc=0;
      if (!empty($this->seArray['DISCOUNTCALC']))
         $dsc=1;

      if ($dsc==0) { // 
         $query="SELECT COUNT(*) FN, SUM(QUANTITY) QUAT,
            SUM(QUANTITY * PRICE) GROSST,
            SUM(QUANTITY * PRICE * (1.0 - (DISCOUNT + ?)/100.0) ) VALT,
		      SUM(QUANTITY * PRICE * (1.0 - (DISCOUNT + ?)/100.0) * VATPER / 100.0) VATT,
		      SUM(QUANTITY * SWEIGHT) WEIT,
            SUM(QUANTITY * SVOLUME) VOLT
            FROM order_line WHERE ORDERID=? AND SUBID=0 AND STATE<2";
      }
      else { // 
         $query="SELECT COUNT(*) FN, SUM(QUANTITY) QUAT,
            SUM(QUANTITY * PRICE) GROSST,
		      SUM(QUANTITY * PRICE * (1.0 - DISCOUNT/100.0) * (1.0 - ?/100.0)) VALT,
		      SUM(QUANTITY * PRICE * (1.0 - DISCOUNT/100.0) * (1.0 - ?/100.0) * VATPER / 100.0) VATT,
		      SUM(QUANTITY * SWEIGHT) WEIT,
            SUM(QUANTITY * SVOLUME) VOLT
            FROM order_line WHERE ORDERID=? AND SUBID=0 AND STATE<2";
      }
      $discount=(float)@$this->seArray['ORDER_DISCOUNT'];
      $data=array( $discount, $discount, (int)$this->seArray['ORDERID'] );
      if ($rs=$this->db->Execute($query,$data)) {
         if ($o1=$rs->FetchObject()) {
            $cot->Nrec=$o1->FN;
            $cot->Tgro=$o1->GROSST;
            $cot->Tqua=$o1->QUAT;
            $cot->Tnet=$o1->VALT;
            $cot->Tvat=$o1->VATT;
            $cot->Twei=$o1->WEIT;
            $cot->Tvol=$o1->VOLT;
            $cot->Tval=$cot->Tnet + $cot->Tvat;
         }
         $rs->Close();
      }
      else
         echo "<h6>".$this->db->ErrorMsg()."</h6>\n";
 	}
	//...................................................
	// cX2::
	function make_header_sub1($ar1)
	{
      $l=strlen($ar1[2]);
      if ($l>3 && strcasecmp(substr($ar1[2],$l-3),'(R)')==0) {
         $wo=substr($ar1[2],0,$l-3);
         $rfr=true;
      }
      else {
         $wo=$ar1[2];
         $rfr=false;
      }

      $opena=false;

		if (!empty($ar1[0])) {
         if (empty($_REQUEST['STANDALONE']) || $rfr) {
            echo "<a href=\"";
   			if (strcmp($ar1[0],'CENTER')==0)
	  			   echo "javascript:goFX('ishop/ishop_m2.php',100)";
            else if (strcmp($ar1[0],'ADMIN')==0)
	  			   echo "javascript:goFX('ishop/ishop_m2.php',500)";
   			else if (strcmp($ar1[0],'INFO')==0)
				  echo "javascript:goFX('ishop/ishop_m2.php',20)";
	  		   else
				  echo $ar1[0];
			   echo "\">";

			   $opena=true;
			}
		}
		
		$arw=explode('/',$wo);
		if (count($arw)==2) {
		   echo myhtml($arw[0])." ";
		   $wo=$arw[1];
      }

      if ((int)$ar1[1]>0)
         $this->xprint($wo);
      else
         echo myhtml($wo);

      if ($rfr) {
         echo ' ('.$this->xxlabel('refresh').')';
      }

      if ($opena)
         echo "</a>";
   }
   //...................................................
   // cX2::
   function make_header($ar2)
   {
      static $done=false;

      if ($done)
         return;

      $n=count($ar2);

      // Save STANDALONE state
      $sa=false;
      if (isset($_POST['STANDALONE']))
         $sa=(int)$_POST['STANDALONE'];
      else if (isset($_GET['STANDALONE']))
         $sa=(int)$_GET['STANDALONE'];
      if ($sa) {
         // Save value
         echo "<script language=javascript>iNoLogout=true;</script>";
         // Overwrite current cookie (if any)
         $_REQUEST['STANDALONE']=$sa;
      }

      // Open table
      echo "<table cellpadding=2 cellspacing=0 border=0 width=\"100%\">
         <tr class=MainMenu>\n";

      // Left cell
      echo "<td align=left>";
      for ($i=0;$i<$n;$i++) {
         if ($i) { echo " &gt; "; }
         $this->make_header_sub1($ar2[$i]);
      }
      echo "</td>\n";

      // Right cell
      echo "<td align=right>".
         "<a href=\"javascript:myHelp()\">".$this->xxlabel('Help')."</a> | <a href=\"javascript:onTips()\">Tips</a> | ";
      if (empty($_REQUEST['STANDALONE'])) {
         if (!empty($this->seArray['OPERID'])) {
            echo "<a href=\"/ishop/restau.htm?FUNCTION=3&CANCEL=1\">Restaurant</a> | ";
         }
   		echo "<a href=\"/ishop/ishop_m2.php?FUNCTION=3\">Logout</a>";
      }
      else {
         echo "<a href=\"javascript:self.close()\">".$this->xxlabel('close')."</a>";
      }
      echo "</td>\n";

      // Finalize
      echo "</tr></table>\n";

      $done=true;
   }
   //...................................................
   // cX2::
   function make_mmenu($themenu, $ar1=false)
   {  //
      // make main menu
      //
      static $done=false;

      if ($done)
         return;
         
      $sa=false;
      if (isset($_POST['STANDALONE']))
         $sa=(int)$_POST['STANDALONE'];
      else if (isset($_GET['STANDALONE']))
         $sa=(int)$_GET['STANDALONE'];
      if ($sa) {
         // Overwrite current cookie (if any)
         $_REQUEST['STANDALONE']=$sa;
      }
      
      // Open table
      echo "<table cellpadding=2 cellspacing=0 border=0 width=\"100%\">
         <tr class=MainMenu>\n";

      $rfr=false;
      
      if ($ar1!==false && !empty($ar1[0])) {
         echo "<td width=16 style=\"background-color:white\"><a href=\"$ar1[0]\"><img src=\"/img/reset.png\" border=0 title=\"Refresh\"></a></td>";
      }
      
      // Left cell
      echo "<td align=left>".strtoupper(substr($themenu,0,1)).strtolower(substr($themenu,1)).": ";
      if ($ar1!==false) {
         $rfr=!empty($ar1[0]);
		   
         $l=strlen($ar1[2]);
         if ($l>3 && strcasecmp(substr($ar1[2],$l-3),'(R)')==0) {
            $wo=substr($ar1[2],0,$l-3);
         }
         else {
            $wo=$ar1[2];
         } 
         
         if ((int)$ar1[1]>0)
            $this->xprint($wo);
         else
            echo myhtml($wo);
      }
      echo "</td>\n";

      // Right cell
      echo "<td align=right>".
         "<a href=\"javascript:myHelp()\">".$this->xxlabel('Help')."</a> | <a href=\"javascript:onTips()\">Tips</a> | ";
      if (empty($_REQUEST['STANDALONE'])) {
         if (!empty($this->seArray['OPERID'])) {
            echo "<a href=\"/ishop/restau.htm?FUNCTION=3&CANCEL=1\">Restaurant</a> | ";
         }
   		echo "<a href=\"/ishop/ishop_m2.php?FUNCTION=3\">Logout</a>";
      }
      else {
         echo "<a href=\"javascript:self.close()\">".$this->xxlabel('close')."</a>";
      }
      echo "</td>\n";

      // Finalize
      echo "</tr></table>\n";

      /*          
      echo '<div id="menu_zone" style="border-top: 1px solid #e0e0e0; border-bottom: 1px solid #404040;"></div>';
      echo "<script>
         dhtmlx.skin='dhx_skyblue';
         var amenu=new dhtmlXMenuObject('menu_zone');
         amenu.setOpenMode('win');
         amenu.setTopText('Pocket.ERP');
         amenu.setIconsPath('../img/dhtmlx/');
         amenu.loadXML('ishop/ishop_xmlmenu.php?m=$themenu');";
      if ($sa) {
         // Save value
         echo "iNoLogout=true;";
      }
      echo "</script>";
      */
      echo "<div id=menu_zone></div>
         <script>
         \$(function()  
         {
            make_menu( \$('#menu_zone'), 'ishop/ishop_xmlmenu.php?m=$themenu&t=json', 'Pocket.ERP' );
         });";
      if ($sa) {
         // Save value
         echo "iNoLogout=true;";
      }
      echo "</script>";         
      
      $done=true;
   }
   //...................................................
   // cX2::
   function print_link($url, $data, $label)
   {
      echo "<a href=\"".make_href($url,$data)."\">".$this->xxlabel($label)."</a>";
   }
   //...................................................
   // cX2::
   function print_return()
   {
   	echo "<b>";
      $this->print_link('ishop/ishop_m2.php', array('FUNCTION'=>100), 'return');
		echo "</b>\n";
	}
   //...................................................
   // cX2::
   function add_tidiff($idate)
   {
		// idate: yyyy-mm-dd hh:mm:ss
		$ar1=explode('-',substr($idate,0,10));
		$ar2=explode(':',substr($idate,11,8));
		$ret=mktime($ar2[0],$ar2[1],$ar2[2],$ar1[1],$ar1[2],$ar1[0]) + (int)$this->seArray['TIDIFF'];
		return $ret;
	}
	//...................................................
	// cX2::
   function add_license_handler(&$mmenu)
	{
      $db=&$this->db;

      $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='CELICENSE_REDUCED' ";
      if (($rs=$db->Execute($query))===false) {
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
		   return;
      }
      if (($o1=$rs->FetchNextObject())!==false) {
         if ($o1->PVALUE==$this->agentid) {
            $mmenu['project'][]=array("javascript:goFX('ishop/adm_lic_min.php',1)", 'license_admin');
         }
      }
      $rs->Close();
   }
   //...................................................
   // cX2::
   function make_item_popup()
   {
      $selx=array(
	      array(1, 'img/open_folder.gif', $this->xxlabel('review') ),
		   array(2, 'img/button_edit.png', $this->xxlabel('edit') ),
         array(54, 'img/photocam.png', $this->xxlabel('foto_zoom') ), 
		   array(100, 'img/copy.gif', $this->xxlabel('copy') ),
		   array(3, 'img/button_drop.png', $this->xxlabel('Delete') ),
		   array(6, 'img/open_subacc.gif', $this->xxlabel('Subitems') ),
		   array(10, 'img/extra16x16.png', 'Extras W/Out' ),
		   array(9, 'img/settings16x16.png', $this->xxlabel('properties') ),
		   array(7, 'img/details.gif', $this->xxlabel('Pricelists') ),
		   array(4, 'img/button_browse.png', $this->xxlabel('stock_acc') ),
		   array(5, 'img/stockon.png', $this->xxlabel('stocks') ),
		   array(8, 'img/statistics.gif', $this->xxlabel('sales_consumption') )
	   );
	   draw_popup($selx,true);
   }
	//...................................................
}
//------------------------------------------------------------------------------
//
// Functions
//
//------------------------------------------------------------------------------
function pr_subheader($title, $show_link=true)
{
   // HEADER
?>
<table cellpadding=4 cellspacing=0 border=0 width="100%">
<tr class=MainMenu>
	<td align=left><?php echo myhtml($title); ?></td>
	<td align=right><?php
		if ($show_link)
			echo "<a href=\"javascript:self.close()\">Close</a>";
		else
			echo "<button type=button  onclick=\"self.close()\">Close</button>";
	?></td>
</tr>
</table>
<?php
}
//--------------------------------------
function make_href($url, $data)
{
   $xret='';
   foreach ($data as $k=>$v) {
		if (empty($xret))
			$xret='?';
		else
			$xret.='&';
      $xret.=$k.'='.myhtml($v);
   }

   if (isset($_REQUEST['SESSIONID'])) {
      if (empty($xret))
      	$xret='?';
   	else
	  	   $xret.='&';
   	$xret.='SESSIONID='.$_REQUEST['SESSIONID'];

	   $xret.='&DELTA='.$_REQUEST['DELTA'];
	}

   return ($url.$xret);
}
//--------------------------------------
function show_newslet_link()
{
   global $x2;
?>
<h5 class=HILINE style="border: 1px solid gray;padding:4px;"><a 
   href="http://www.incahellas.com/inca/newsletter_gr.htm" target="_blank"><?php $x2->xprint('reg_newsletter'); ?></a>
   &nbsp;&nbsp;<?php $x2->xprint('inst_upd_info'); ?>
   &nbsp;&nbsp;<a href="http://www.incahellas.com/inca/newslet.php" target="_blank"><?php $x2->xprint('prev_newsletter'); ?>&nbsp;&gt;&gt;</a></h5>
<?php
}
function list_databases()
{
   $x=0;
   include(DOCUMENT_ROOT."/ishop/ishop_db.php");
   
   $fdb=DOCUMENT_ROOT."/ishop/ishop_db.php";
   
   if (($fp=@fopen($fdb,"rb"))===false) {
      echo "Could not open $fdb file!";
      return;
   }
   $id=0;
   $profiles=array();
   $data1=array();
   $indata=false;
   while (($buf=fgets($fp,1024))!==false) {
      if (!$indata && strstr($buf, 'switch ($x)')!==false) {
         $indata=true;
         continue;
      }
      
      if (!$indata)
         continue;
         
      $buf1=trim($buf);
      $buf2=trim($buf1,';');

      if ($buf2=='break') {
         $profiles[$id]=$data1;
         $data1=array();
         continue;
      }

      $ar1=explode('=',$buf2,2);
      if (count($ar1)==2) {
         if ($ar1[0]{0}=='$') {
            $l=strlen($ar1[1]);
            if ($ar1[1]{0}=='\'' || $ar1[1]{0}=='"')
               $s2=substr($ar1[1],1,$l-2);
            else {
               $s2=$ar1[1];
            }
            $data1=array_merge($data1, array( substr($ar1[0],1) => $s2 ) );
         }
         continue;
      }

      $ar1=explode(' ',$buf2,2);
      if (count($ar1)==2) {
         if ($ar1[0]=='case') {
            $id=(int)$ar1[1];
         }
         continue;
      }
   }
   fclose($fp);

   // Reparse $profiles, make jscript code
   $ar1=array('DB_Profile', 'DB_Type', 'DB_Host', 'DB_User', 'DB_Pass', 'DB_Catalog');
   echo "<script language=javascript>
      var profiles={\n";
   $n=0;
   foreach ($profiles as $k1=>$v1) {
      echo "\t'$k1':{";
      foreach ($ar1 as $k2) {
         echo "'$k2':'".addslashes((string)@$v1[$k2])."', ";
      }
      echo "'null':null },\n";
      $n++;
   }
   echo "'null':null };
      function dbid_change() {
         var i=document.getElementById('dbid').selectedIndex;
         if (i<0) i=0;
         k1=document.getElementById('dbid').options[i].value;
         var f1=document.forms[0];
         f1.DB_Overwrite.value=1;
         f1[k2='DB_Type'].value=profiles[k1][k2];
         f1[k2='DB_Host'].value=profiles[k1][k2];
         f1[k2='DB_User'].value=profiles[k1][k2];
         f1[k2='DB_Pass'].value=profiles[k1][k2];
         f1[k2='DB_Catalog'].value=profiles[k1][k2];
      }
      </script>";

   // Reparse $profiles, make html code
   $selector=array();
   foreach ($profiles as $k1=>$v1) {
      if (!empty($v1['DB_Profile'])) {
         $selector[$k1]=$k1.'# '.$v1['DB_Profile'];
      }
      else {
         $selector[$k1]=$k1.'# '.(@$v1['DB_Type']);
      }
   }
   echo "<select id=dbid onchange=\"dbid_change()\">";
   prAssocSelect($selector,$x);
   echo "</select> (default=${x}#)";
}
//--------------------------------------
function print_all_versions()
{
   global $db;
?>
<table border=0>
<colgroup class=bgLabel></colgroup>
<colgroup class=bgInput></colgroup>
<tr>
   <td>Program</td>
   <td><b><?php echo MY_VERSION; ?></b></td>
</tr>
<tr>
   <td>PHP</td>
   <td><?php echo myhtml(PHP_VERSION.' ('.PHP_OS.') '.PHP_SAPI); ?></td>
</tr>
<tr>
   <td>ADO</td>
   <td><?php
		global $ADODB_vers;

   	$ar1=explode(' ',$ADODB_vers);
		echo @$ar1[0];

		if (defined('ADODB_EXTENSION')) {
         echo " Extension: ".ADODB_EXTENSION;
      }
		?></td>
</tr>
<tr>
   <td>Zend Framework</td>
   <td><?php
		@include_once('../lib/Zend/Version.php');
      if (class_exists('Zend_Version')) {
         echo Zend_Version::VERSION;
      }
      else {
         echo "Not found";
      }
		?></td>
</tr>
<tr>
   <td>Php Excel</td>
   <td><?php
		if (($ar1=file('../lib/PHPExcel.php'))!==false) {
         foreach ($ar1 as $line){
            $k='@version';
            $klen=strlen($k);
            if (($j=strpos($line, $k))!==false) {
               echo trim(substr($line,$j+$klen));
            }
         }
      }
      else {
         echo "Not found";
      }
		?></td>
</tr>
<tr>
   <td>FCGI server</td>
   <td><?php
	   if (isset($_SERVER['FCGI_SERVER_VERSION']))
         echo $_SERVER['FCGI_SERVER_VERSION'];
      else if (isset($_SERVER['FCGI_ROLE']))
         echo "Role=".$_SERVER['FCGI_ROLE'];
      else
         echo "no fcgi detected";
      ?></td>
</tr>
<tr>
   <td>Server software</td>
   <td><?php
      echo myhtml(@$_SERVER['SERVER_SOFTWARE']);
   ?></td>
</tr>
<tr>
   <td>Document Root</td>
   <td><?php
      echo myhtml(DOCUMENT_ROOT);
   ?></td>
</tr>
<tr>
   <td>Database</td>
   <td><?php
   	if ($db===false) {
         ; // nothing we can do
      }
      else if ($db->databaseType=='mysqlt') {
         echo "(MySql) ";
         $query="SHOW VARIABLES LIKE 'version'";
         if ($rs=$db->Execute($query)) {
            if ($o1=$rs->FetchNextObject()) {
               echo myhtml($o1->VALUE);
            }
            $rs->Close();
         }
         else {
            echo $db->ErrorMsg();
         }
    	}
    	else {
         echo "(MS-SQL) ";
         $query="SELECT SERVERPROPERTY('productversion'), SERVERPROPERTY ('productlevel'), SERVERPROPERTY ('edition')";
			if ($rs=$db->Execute($query)) {
            if ($row=$rs->FetchRow()) {
               echo myhtml(implode(' ',$row));
            }
            $rs->Close();
         }
         else {
            echo $db->ErrorMsg();
         }
		}
      ?></td>
</tr>
<tr>
   <td>jQuery</td>
   <td id=jqver></td>
</tr>
<tr>
   <td>Browser Name</td>
   <td id=bname></td>
</tr>
<tr>
   <td>CodeName</td>
   <td id=bcdname></td>
</tr>   
<tr>
   <td>Version</td>
   <td id=bver></td>
</tr>
<tr>
   <td>Platform</td>
   <td id=navpl></td>
</tr>
<tr>
   <td>CPU class</td>
   <td id=ncpu></td>
</tr>
<tr>
   <td>Cookies Enabled</td>
   <td id=bcen></td>
</tr>
</table>
<script>
var s1 = $().jquery;
for (var p in $.support) {
   s1 += " "+p+"="+$.support[p];
}
$('#jqver').text( s1 );
$('#bcdname').text( navigator.appCodeName );
$('#bname').text( navigator.appName );
$('#bver').text( navigator.appVersion );
$('#navpl').text( navigator.platform );
$('#ncpu').text( navigator.cpuClass );
$('#bcen').text( navigator.cookieEnabled );
</script>
<?php
}
//--------------------------------------
function https_can_open()
{
   // create a new curl resource
   if (($ch = curl_init())===false)
      return false;

   // set URL and other appropriate options
   curl_setopt($ch, CURLOPT_URL, "https://".$_SERVER['HTTP_HOST']);
   curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
   curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
   curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

   // grab URL and pass it to the browser
   $rets=curl_exec($ch);
   /*
   if ($rets===false) {
      echo curl_error($ch);
   }
   */
      
   // close curl resource, and free up system resources
   curl_close($ch);
   
   return ($rets!==false);
} 
//--------------------------------------
function request_login($show_full_UI=true)
{
   $prof=new cPROFILER1();
   
   if ((!empty($_REQUEST['RESELID']) || !empty($_REQUEST['LGTYPE'])) && !isset($_REQUEST['merchant']))
      $get_reselid=true;
   else
      $get_reselid=false; // get merchant

   $sslAvail=( strcmp(HTTP_HOST,'www.incahellas.gr')==0
      || strcmp(HTTP_HOST,'www.e-invoice-gr.info')==0  
      /*|| https_can_open() commented for syfa, 13/12/2010 */
      );
?>
<p></p>
<script src="ishop/ishop_inc1.js.php"></script>
<script>
function array_z2(js)
{
   for (i = 0; i < this.length; i++) {
      this[i] = zero2(this[i]);
   }
   return this.join(js);
}
Array.prototype.z2 = array_z2;
function filldatetime()
{
   var f1=document.forms[0];
   var d1=new Date();
   f1.CLIDATE.value=( [d1.getFullYear(), d1.getMonth()+1, d1.getDate()] ).z2('-');
   f1.CLITIME.value=( [d1.getHours(), d1.getMinutes(), d1.getSeconds()] ).z2(':');
	return true;
}
function winRet(x)
{
	resetDB(x);
}
</script>
<?php
   if ($show_full_UI) {
      show_newslet_link();
   }
?>
<form method=POST action="<?php echo $show_full_UI?'/ishop/ishop_m2.php':'/ishop/ishop_login.php'; ?>"
   onsubmit="return filldatetime()">
<input type=HIDDEN name="FUNCTION" value="1">
<input type=HIDDEN name="CLIDATE">
<input type=HIDDEN name="CLITIME">
<input type=HIDDEN name="DB_Overwrite">
<input type=HIDDEN name="DB_Type">
<input type=HIDDEN name="DB_Host">
<input type=HIDDEN name="DB_User">
<input type=HIDDEN name="DB_Pass">
<input type=HIDDEN name="DB_Catalog">
<table border=0>
<tr>
   <td class=bgLabel>Database</td>
   <td class=bgInput><?php list_databases(); ?></td>
</tr>

<tr>
   <td class=bgLabel>Login Type</td>
   <td class=bgInput>
      <input type=RADIO name="LGTYPE" id=lgtyp0 <?php if ((int)$get_reselid==0) echo 'checked'; ?> value="0"><label for=lgtyp0>Administrator</label>
      <input type=RADIO name="LGTYPE" id=lgtyp1 <?php if ((int)$get_reselid!=0) echo 'checked'; ?> value="1"><label for=lgtyp1>User</label>
      </td>
</tr>

<tr>
	<td class=bgLabel><!-- Admin -->Login</td>
	<td class=bgInput>
      <span id=lpath <?php if ($sslAvail && $show_full_UI) { echo "style=\"display:none;\""; } ?> ><input
		   type=TEXT value="<?php
      	if (isset($_REQUEST['merchant']))
            echo myhtml($_REQUEST['merchant']);
         else
            echo myhtml(@$_REQUEST['LPATH']);
   	  ?>" name="LPATH" style="width:120px;"></span>
   </td>
</tr>
<tr>
	<td class=bgLabel>Password</td>
	<td class=bgInput><span <?php if ($sslAvail && $show_full_UI) echo "style=\"display:none;\""; ?> id=passwd><input
		type=PASSWORD name="PASSWD" style="width:120px;"></span></td>
</tr>

<?php
   if ($show_full_UI) {
      //
      //  ( unsecure) login 2
      //
      echo "<tbody id=normlogin ";
      if ($sslAvail) {
         echo "style=\"display:none;\"";
      }
      echo "><tr>
      	<td></td>
	      <td colspan=3 class=bgButton>";
	   if (@$_SERVER['HTTPS']=='on') {
         echo "<button type=SUBMIT class=uibutton1 name=\"ok\"
            onclick=\"document.forms[0].submit();\"><img
            src=\"/img/lock16x16.png\"	align=absmiddle height=16 width=16> Login</button>";
      }
      else {
         echo "<input type=SUBMIT class=uibutton1 name=\"ok\" value=\"Login\" onclick=\"document.body.onbeforeunload=bodyUnloading;\">".
            "<input type=BUTTON class=uibutton1 value=\"Reset\" onClick=\"show_popup(document.getElementById('popmenu'))\">".
            "<input type=BUTTON class=uibutton1 name=\"X\" value=\"Close\" onclick=\"top.close()\">
   		   <b><a href=\"javascript:goSecureLogin()\">Secure login</a></b>";
   	}
      echo "</td></tr></tbody>\n";
	   //
	   // Secure login 2
	   //
	   echo "<tbody ";
      if ($sslAvail==false) {
         echo " class=hidden ";
      }
      echo "id=seculogin><tr>
      	<td></td>
	      <td colspan=3 class=bgButton><button type=button 
            class=uibutton1 onclick=\"secure_login()\"><img src=\"/img/lock16x16.png\"
				align=absmiddle height=16 width=16> Login</button><input type=BUTTON class=uibutton1 value=\"Reset\"
			   onClick=\"javascript:window.alert('Go [unsecure login], then press [reset].')\"><input
				class=uibutton1 type=BUTTON name=\"X\" value=\"Close\" onclick=\"self.close()\">";
		if (empty($_SESSION['EINVONLY'])) {
      	echo "<b><a href=\"javascript:goUnsecLogin()\">Unsecure Login</a></b>";
      }
      echo "</td>
         </tr></tbody>\n";

      // Secondary buttons line 2/3
      if (empty($_SESSION['EINVONLY'])) {
         echo "<tr>
            <td align=right class=bglabel>PDA:</td>
   	      <td colspan=4 class=bgInput>http://<a href=\"javascript:window.alert('Replace with your server\'s name or IP')\"
               style=\"border-bottom: 1px dashed red;\">serverIP</a>/pda/index.htm</td>
            </tr>
            <tr>
            <td></td>
            <td colspan=4 class=bgButton>
            	<button type=button class=uibutton1	onclick=\"newWinEx('/pda/index.htm',2);\"><img
			   	src=\"/img/ie16x16.png\" align=absmiddle height=16 width=16>User PC</button>
               <button type=button class=uibutton1 onclick=\"newWinPDA()\"><img
	  			   src=\"/img/ie16x16.png\" align=absmiddle height=16 width=16>User PDA</button>
               <button type=button class=uibutton1 
               onclick=\"location.href='/ishop/restau.htm';\">ORDER Plus</button>";
         if (show_UniPOS()) {
            echo "<button type=button class=uibutton1 
              onclick=\"location.href='/ishop/unipos.htm';\">UniPOS</button>";
		   }
		   if (!empty($_SESSION['ExtraButton'])) {
		      foreach ($_SESSION['ExtraButton'] as $cfga) {
		         echo "<button type=button class=uibutton1 onclick=\"location.href='".myhtml($cfga[1])."';\">".myhtml($cfga[0])."</button>";
            }
         }
         echo "&nbsp;<b><a href=\"javascript:myHelp()\">Help</a></b></td></tr>";
      }
   } // if ($show_full_UI)
   else {
      // Not full UI 2
      echo "<tr>
      	<td></td>
	      <td colspan=3 class=bgButton><button type=button  class=uibutton1
            onclick=\"filldatetime();document.forms[0].submit()\"><img
            src=\"/img/lock16x16.png\"	align=absmiddle height=16 width=16>
            Login</button><input class=uibutton1 type=BUTTON name=\"X\"
				value=\"Cancel\" onclick=\"unsecure_login()\">
         </td></tr>\n";
   }
?>
<tr>
   <td colspan=4 style="padding-top:10px;">
      <?php
      if ($show_full_UI && empty($_SESSION['EINVONLY'])) {
         php_checks(false);        
      }
   ?></td>
</tr>
<tr class=bgHeader>
   <td colspan=2>Version numbers</td>
   <?php
      if ($show_full_UI && empty($_SESSION['EINVONLY'])) {
         echo "<td width=10></td>
            <td>History</td>";
      }
   ?>
</tr>   
<tr valign=top>
   <td colspan=2><?php
      print_all_versions();
      ?></td>
   <?php
      if ($show_full_UI && empty($_SESSION['EINVONLY'])) {
         echo "<td width=10></td>
            <td class=bgInput>";
         ?>
         <div style="height:160px; overflow:auto" id=hist></div>
         <script>
         var url='/ishop/ishop_history6.php?FX=1';
         $('#hist').load(url);
         </script>
         <?php
         echo "<p></p><a href=\"/ishop/ishop_history6.php\" target=history>Full history details</a>";
         echo "</td>";
      }
   ?>
</tr>
</table>
</form>

<?php
   if ($show_full_UI && empty($_SESSION['EINVONLY'])) {
?>   
<div id=unistart style="display:none;" title="New program version!">This 
         version requires <i>UniStart</i>, in order to work smoothly.
         <p></p> 
         Please<br> 
         <a href="http://www.incahellas.com/ishop/downloader.php?FNAME=/ftp/ishop/UniStart/UniStartSetup.exe">download 
         and install UniStart</a><br>
         now! 
</div>
<script>
var need_show_dlg=false;
try {
   if (!external || !external.Text || external.Text.indexOf('UniStart')==-1)
      need_show_dlg=true;
}
catch (e) { need_show_dlg=true; }
if (need_show_dlg) {
   $('#unistart').dialog( {resizable: false, width:400, modal:true} );
}
</script>
<?php      
   }
   // Popup must be drawn last in page in order to have a proper z-index
   $selx=array(
      array(-3, 'img/go_next.gif', 'Load lexicon' ),
		array(-2, 'img/go_next.gif', 'Check files' ),
		array(-1, 'img/go_next.gif', 'Check all' )
   );
	draw_popup($selx,false);
}
//--------------------------------------
function display_body($s1)
{
   $i1=strpos($s1, '<body');
   if ($i1===false) {
      echo $s1;
      return;
   }
   $i2=strpos($s1, '>', $i1+1);
   if($i2===false)
      return;
      
   $i3=strpos($s1, '</body', $i2+1);
   if ($i3===false)
      echo substr($s1, $i2+1);
   else
      echo substr($s1, $i2+1, $i3-$i2-1);
}
//--------------------------------------
function show_UniPOS()
{
   if (PHP_OS!='WINNT')
      return true;
      
   // Set default
   $x=0;

   // Initialize from registry
   $shell = new COM("WScript.Shell");
   if ($shell==null) {
      echo "COM object failed!\n";
      return false;
   }

   $basekey="HKEY_LOCAL_MACHINE\\SOFTWARE\\INCA Hellas\\iShopping Cart\\";
   try {
      $x=@$shell->RegRead( $basekey.'UNIPOS' );
   }
   catch (Exception $e) {}
   $shell=null;

   return (bool)((int)$x);
}
//--------------------------------------
function process_login(&$message)
{
   global $x2;

   $fu=0; // reset to error condition

	do {
		$errstr="";
      
		if ($x2->confirm_login($errstr)===false) {
         if (!empty($errstr))
            echo "ERR=$errstr\n";

			$message="Login failed. Please repeat!";
			break;
		}

		if ($x2->isadmin==1000) { // ok superuser
			$fu=500;
   		$x2->lpath="Superuser";
   		$data=array( 'LPATH'=>$x2->lpath );
		   $x2->addArray($data);
   	}
		else { // ok, normal
			$x2->read_agent_main();
			$fu=100;
		}

	} while(0);

	return $fu;
}
//--------------------------------------
function print_page_header($fu=0)
{
 	global $x2;

   if ($x2->reselid==0) { // admin
      echo "<table cellspacing=0 cellpadding=0 border=0 width=\"100%\">
         <tr title=\"".$_SERVER['PHP_SELF']."::".$fu."\">
      	<td background=\"ishop/back1.gif\"><nobr><b>xSetup for
         <span title=\"Agent Id ".$x2->agentid."# ".myhtml(@$x2->Agp['TITLE'])."\" class=AGENT>".
         $x2->lpath."</span></b></nobr></td>
	      <td background=\"ishop/back1.gif\" valign=top><img src=\"ishop/ltop.gif\"></td>
	      <td background=\"ishop/ttop.gif\" valign=top><a href=\"http://www.incahellas.com\" target=_top><img
		   src=\"ishop/logo.gif\" alt=\"iShopping cart logo\" border=0 align=absmiddle></a></td>
	      <td background=\"ishop/ttop.gif\" width=\"99%\"><span style=\"padding-left:10px;color:gray;\">at</span>
         <span style=\"color:white;\">".strtoupper(HTTP_HOST)."</span></td>
         <td background=\"ishop/ttop.gif\"><button type=button  
         style=\"right:14px;top:4px;position:absolute;padding:2px;width:24px;height:24px;\"
         onclick=\"window.print()\"><img src=\"/img/printer16x16.png\"></button></td>
         </tr>
         </table>";
	}
	else { // reseller
	   echo "<table cellspacing=0 cellpadding=0 border=0 width=\"100%\" height=35>
         <tr title=\"".$_SERVER['PHP_SELF']."::".$fu."\" style=\"background-image: url(ishop/ttop.gif);\">
         <td style=\"padding-left:5px;\"><span class=xheadn title=\"Agent Id ".
         $x2->agentid."#\"><nobr>".myhtml($x2->Agp['TITLE'])."</nobr></span></td>
         <td><span class=xheadn><nobr>".myhtml($x2->seArray['RE_NAME'])."</nobr></span><td>
         <td><span style=\"padding-left:5px;color:gray;\">at</span></td>
         <td><span style=\"padding-left:5px;color:white;\">".strtoupper(HTTP_HOST)."</span></td>
         <td align=right style=\"padding-right:5px;\" width=\"99%\"><a
            href=\"http://www.incahellas.com/ishop/index.htm\"><img src=\"ishop/logo.gif\"
            alt=\"iShopping cart logo\" border=0></a></td>
         <td background=\"ishop/ttop.gif\"><button type=button  onclick=\"window.print()\"><img
            src=\"/img/printer16x16.png\"></button></td>
         </tr>
         </table>";
   }
}
//--------------------------------------
function tr437_928($src, $is437)
{
	global $a437,$a928;

	if ($is437)
		$a=strtr($src,$a437,$a928);
	else
		$a=strtr($src,$a928,$a437);

	return $a;
}
//--------------------------------------
function printWareHouse($db, $warehouseid=0)
{
   global $x2;

   $ar1=array();
   $query="SELECT MENUID, MENUDES FROM menurep WHERE AGENTID=? AND MENUTYPE=1 ORDER BY MENUID";
   $data=array($x2->agentid);
   if ($rs=$db->Execute($query,$data)) {
      while ($o1=$rs->FetchNextObject()) {
         $ar1[$o1->MENUID]=$o1->MENUID."# ".$db->verify_8($o1->MENUDES);
      }
      $rs->Close();
   }
   if (array_key_exists(0,$ar1)) {
      $ar1[0]='0# '.$x2->xlabel('without');
      ksort($ar1);
   }
   prAssocSelErr($ar1,$warehouseid);
}
//--------------------------------------
function confirm_pwd(&$db)
{
 	$o1=false;
 	
 	if (!empty($_REQUEST['LGTYPE'])) {
      $_REQUEST['RESELID']=@$_REQUEST['LPATH'];
      $_REQUEST['REPASS']=@$_REQUEST['PASSWD'];

      $_REQUEST['LPATH']='';
      $_REQUEST['PASSWD']='';
   }

	if (!empty($_REQUEST['LPATH'])) {
		if (!isset($_REQUEST['PASSWD']))
			return false;

	 	$query="SELECT LPATH, AGENTID, ISADMIN, 0 RESELID, '' RE_NAME FROM agents 
		 	WHERE LPATH=? AND PASSWD=?";
 		$data=array($_REQUEST['LPATH'], $_REQUEST['PASSWD']); 
	 	if (!($rs=$db->Execute($query,$data))) {
			echo "<h6>".$db->ErrorMsg()."</h6>\n";
			return false;
		}
		$o1=$rs->FetchNextObject();
		$rs->Close();
	}
	else if (!empty($_REQUEST['RESELID'])) {
		if (!isset($_REQUEST['REPASS']))
			return false;

		$query="SELECT T2.LPATH, T1.AGENTID, T2.ISADMIN, T1.RESELID, RE_NAME FROM reseller T1
			INNER JOIN agents T2 ON (T2.AGENTID=T1.AGENTID)
			INNER JOIN reselpref T3 ON (T3.RESELID=T1.RESELID AND PNAME='DESKTOP_LOGIN' AND PVALUE='1')
			WHERE T1.RESELID=? AND T1.PASSWD=?";
 		$data=array($_REQUEST['RESELID'], (string)$_REQUEST['REPASS']);
	 	if (!($rs=$db->Execute($query,$data))) {
			echo "<h6>".$db->ErrorMsg()."</h6>\n";
			return false;
		}
		$o1=$rs->FetchNextObject();
      if ($o1!==false) {
         $db->verify_8($o1->RE_NAME);
      }
		$rs->Close();
	}
	else {
		return false;
	}

	return $o1;
}
//--------------------------------------
function make_combo($fld_name, $ar1, $val)
{
   echo "<select id=\"".$fld_name."_sid\"";
   if (!empty($val)) echo " style=\"display:none;\"";
   echo " onchange=\"combo_change()\">\n";
   prAssocSelect($ar1,0);
   echo "</select><input type=TEXT name=\"".$fld_name."\" id=\"".$fld_name."_tid\" ";
   if (empty($val)) echo " style=\"display:none;\"";
   echo " value=\"".myhtml($val)."\">
      <a id=\"".$fld_name."_aid\" href=\"javascript:combo_sh()\"
      class=\"LocalHref\" style=\"font-weight:bold;\">".(empty($val)?'[+]':'[...]')."</a>";
?>
<script language=javascript>
function combo_change()
{
   var sid=document.getElementById('<?php echo $fld_name; ?>_sid');
   var tid=document.getElementById('<?php echo $fld_name; ?>_tid');
   if ((i=sid.selectedIndex)>=0)
      tid.value=sid.options[i].text;
   else
      tid.value='';
}
function combo_sh()
{
	var sid=document.getElementById('<?php echo $fld_name; ?>_sid');
   var tid=document.getElementById('<?php echo $fld_name; ?>_tid');
   var aid=document.getElementById('<?php echo $fld_name; ?>_aid');

   if (sid.style.display=='none') {
      //sid.style.visibility='visible';
      sid.style.display='inline';
      //tid.style.visibility='hidden';
      tid.style.display='none';
      combo_change();
      aid.innerText='[+]';
   }
   else {
      //sid.style.visibility='hidden';
      sid.style.display='none';
      //tid.style.visibility='visible';
      tid.style.display='inline';
      aid.innerText='[...]';
   }
}
<?php if (empty($val)) echo "combo_change();"; ?>
</script>
<?php
}
//--------------------------------------
function invert_date($src)
{
   $src2=strtr($src,"/,;\\","----");
   $a=explode('-',$src2);
   if (count($a)!=3)
      return $src;
   else {
      $ret=$a[2].'-'.$a[1].'-'.$a[0];
      return $ret;
   }
}
//--------------------------------------
function item_del_cleardup()
{
   global $x2;
 	$db=&$x2->db;

   $rows=array();
   $query="SELECT T1.CODE FROM ishop_item_del T1
      LEFT JOIN ishop_item T2 ON (T2.AGENTID=T1.AGENTID AND T2.CODE=T1.CODE)
      WHERE T1.AGENTID=? AND T2.CODE IS NOT NULL";
   $data=array($x2->agentid);
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   while ($row=$rs->FetchRow()) {
      $rows[]=$db->verify_8($row[0]);
   }
   $rs->Close();

   if (($n=count($rows))>0) {
      $q1=array_fill( 0, $n, '?');
      $query="DELETE FROM ishop_item_del WHERE AGENTID=? AND CODE IN (".implode(',',$q1).")";
      $data=array_merge( array($x2->agentid), $rows );
      if (!$db->Execute($query,$data)) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         return false;
      }
   }

   return true;
}
//--------------------------------------
function mbr_del_cleardup()
{
   global $x2;
 	$db=&$x2->db;

   $rows=array();
   $query="SELECT T1.LOGIN FROM ishop_mbr_del T1
      LEFT JOIN ishop_mbr T2 ON (T2.AGENTID=T1.AGENTID AND T2.LOGIN=T1.LOGIN)
      WHERE T1.AGENTID=? AND T2.LOGIN IS NOT NULL";
   $data=array($x2->agentid);
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   while ($row=$rs->FetchRow()) {
      $rows[]=$db->verify_8($row[0]);
   }
   $rs->Close();

   if (($n=count($rows))>0) {
      $q1=array_fill( 0, $n, '?');
      $query="DELETE FROM ishop_mbr_del WHERE AGENTID=? AND LOGIN IN (".implode(',',$q1).")";
      $data=array_merge( array($x2->agentid), $rows );
      if (!$db->Execute($query,$data)) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         return false;
      }
   }

   return true;
}
//--------------------------------------
function discount_del_cleardup()
{
   global $x2;
 	$db=&$x2->db;

   $recs=array();
   $query="SELECT * FROM ishop_discount_del T1
      LEFT JOIN ishop_discount T2 ON (T2.AGENTID=T1.AGENTID AND 
      T2.CSALESGRP1=T1.CSALESGRP1 AND T2.ISALESGRP1=T1.ISALESGRP1 AND 
      T2.DATEFROM=T1.DATEFROM AND T2.QUA1=T1.QUA1)
      WHERE T1.AGENTID=? AND T2.AGENTID IS NOT NULL";
   $data=array($x2->agentid);
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>";
      return false;
   }
   while ($o1=$rs->FetchNextObject()) {
      $recs[]=$o1;
   }
   $rs->Close();

   $n=count($recs);
   for ($i=0;$i<$n;$i++) {
      $o1=$recs[$i];
      $query="DELETE FROM ishop_discount_del WHERE AGENTID=? AND CSALESGRP1=? AND ISALESGRP1=? AND DATEFROM=? AND QUA1=?";
      $data=array($o1->AGENTID, $o1->CSALESGRP1, $o1->ISALESGRP1, $o1->DATEFROM, $o1->QUA1 );
      if (!$db->Execute($query,$data)) {
         echo "<h6>".$db->ErrorMsg()."</h6>";
         return false;
      }
   }

   return true;
}
//--------------------------------------
function pre_body_close()
{
?>
<script type="text/javascript">
if (iNoLogout) {
   var f1=document.goForm;
   if (f1!=null) {
      if (oStdAlone==null)
         oStdAlone=f1.STANDALONE;
      if (oStdAlone==null) { // still null
         oStdAlone=document.createElement('INPUT');
         oStdAlone.type='HIDDEN';
         oStdAlone.name='STANDALONE';
         f1.appendChild(oStdAlone);
      }
      oStdAlone.value="1";
   }
}
</script>
<?php
}
//--------------------------------------
class cVIEW
{
	var $base=true;
	var $fields;
	var $sort;
	var $from;
	var $to;
	var $query;
	var $data;     

	function cVIEW()
	{
		$this->fields=array();
		$this->sort=array();
		$this->from=array();
		$this->to=array();
		$this->diff=array();
	}

	function load( $viewid )
	{
		global $x2;
		$db=&$x2->db;

		$query="SELECT * FROM ishop_view_field 
         WHERE VIEWID=? AND VFTYPE IN (0,1) 
         ORDER BY VFTYPE, VFSEQ";
		$data=array( $viewid );
		if (($rs=$db->Execute($query,$data))===false) {
			echo "<h6>".$db->ErrorMsg()."</h6>";
			return false;
		}
		while ($o2=$rs->FetchNextObject()) {
			if ($o2->VFTYPE==0) {
				$this->fields[]=$o2->VIFIELD;
			}
			else if ($o2->VFTYPE==1) {
				$this->sort[]=$o2->VISORT==0?$o2->VIFIELD:($o2->VIFIELD.' DESC');
			}
		}
		$rs->Close();

		// Filters
   	$query="SELECT T1.VIFIELD, T2.PVALUE VIFROM, T3.PVALUE VITO, T4.PVALUE VIDIFF FROM ishop_view_field T1
			LEFT JOIN reselprefex T2 ON (T2.AGENTID=? AND T2.RESELID=? AND T2.PGROUP=? AND T2.PNAME=CONCAT('FROM_', T1.VIFIELD) )
			LEFT JOIN reselprefex T3 ON (T3.AGENTID=? AND T3.RESELID=? AND T3.PGROUP=? AND T3.PNAME=CONCAT('TO_', T1.VIFIELD) )
			LEFT JOIN reselprefex T4 ON (T4.AGENTID=? AND T4.RESELID=? AND T4.PGROUP=? AND T4.PNAME=CONCAT('DIFF_', T1.VIFIELD) )
			WHERE T1.VIEWID=? AND T1.VFTYPE=2 
         ORDER BY T1.VFSEQ";
		$data=array( $x2->agentid, $x2->reselid, 'view_filter_'.$viewid,
			$x2->agentid, $x2->reselid, 'view_filter_'.$viewid,
			$x2->agentid, $x2->reselid, 'view_filter_'.$viewid,
			$viewid );
	   if (($rs=$db->Execute($query,$data))===false) {
			echo "<h6>".$db->ErrorMsg()."</h6>";
			return false;
		}
		while ($o2=$rs->FetchNextObject()) {
			if (strlen($o2->VIFROM)>0)
				$this->from[ $o2->VIFIELD ]=$o2->VIFROM;
			if (strlen($o2->VITO)>0)
				$this->to[ $o2->VIFIELD ]=$o2->VITO;
			if (strlen($o2->VIDIFF)>0)
				$this->diff[ $o2->VIFIELD ]=$o2->VIDIFF;
		}
		$rs->Close();

		return true;
	}

	function make_query($t1)
	{
		global $x2;
		$db=&$x2->db;

		$t2=false;
		$fss=array();
		foreach ($this->fields as $f1) {
         if ($f1{0}=='#') {
            ;
         }
			else if (strcmp($f1,'PAGENO')==0) {
				$fss[]="CONCAT(T1.PAGENO, ' ', IF (T2.ABBREV IS NULL,'',T2.ABBREV)) PAGENO";
				$t2=true;
			}
			else {
				$fss[]='T1.'.$f1;
			}
		}
		$this->query="SELECT ".implode(",", $fss)." FROM ".$t1." T1 ";
		if ($t2) {
			$this->query .= " LEFT JOIN ishop_ctg T2 ON (T2.AGENTID=T1.AGENTID AND T2.PAGENO=T1.PAGENO) ";
		}

		if (($cols=$db->MetaColumns($t1))===false) {
			echo "<h6>".$db->ErrorMsg()."</h6>";
			return;
		}
		$fss=array();
		foreach ($cols as $col1) {
			$fss[ $col1->name ]=$col1;
		}

		$this->query .= " WHERE T1.AGENTID=? ";
   	$this->data=array($x2->agentid);
	   
		foreach ($this->from as $k=>$v) {
			$this->query .= " AND T1.".$k." >= ? ";
			if (array_key_exists($k,$fss) && $db->MetaType( $fss[$k] )=='N')
				$this->data[]=toFloat($v);
			else
				$this->data[]=$v;
		}
		
		foreach ($this->to as $k=>$v) {
			$this->query .= " AND T1.".$k." <= ? ";
			if (array_key_exists($k,$fss) && $db->MetaType( $fss[$k] )=='N')
				$this->data[]=toFloat($v);
			else
				$this->data[]=$v;
		}
		
		foreach ($this->diff as $k=>$v) {
			$this->query .= " AND T1.".$k." != ? ";
			if (array_key_exists($k,$fss) && $db->MetaType( $fss[$k] )=='N')
				$this->data[]=toFloat($v);
			else
				$this->data[]=$v;
		}
		
		if (!empty($_REQUEST['SEARCH'])) {
         $search = $_REQUEST['SEARCH'];
         $sab=(int)@$_SESSION['SEARCHABOUT'];
         if ($sab) {
			   $this->query .= " AND T1.TRKEY LIKE ? ";
			   $xs1='%'.ToEnglish($search).'%';
			   $this->data[]=$xs1;
         }
         else {
            $xs1='%'.$search.'%';
            if (strcmp($t1,'ishop_item')==0) {
               $this->query .= " AND (T1.CODE LIKE ? OR T1.NAME LIKE ?) ";
               array_push($this->data, $xs1);
            }
            else {
               $this->query .= " AND (T1.LOGIN LIKE ? OR T1.COMPANY LIKE ?) ";
               array_push($this->data, $xs1, $xs1);
            }
         }
		}

		if (($n=count($this->sort))>0) {
			$fss=array();
			foreach ($this->sort as $f1) {
				$fss[]='T1.'.$f1;
			}
			$this->query .= " ORDER BY ".implode(",", $fss);
		}
	}
}
//--------------------------------------
function php_checks($check_db)
{                  
   global $db;
    
 	echo "<div style=\"color: red; background-color: #D0D0D0;\">\n";

 	if (version_compare(PHP_VERSION, '5.2.14')<0) {
      echo "<h4>PHP incorrect version!</h4>";
   }

 	if (($t1=tempnam ( "c:\\tmp", "FOO"))===false) {
      echo "<h4>Warning: could not obtain temporary filename!</h4>\n";
   }
   else {
    	$d1=dirname($t1);
 	   if (!is_dir($d1))
         echo "<h4>Warning: you need create $d1 dir.!</h4>\n";
      else
         unlink($t1);
   }
   
   if ($check_db) {
		if ($db->databaseType=='mysqlt') {
	      $query="SHOW VARIABLES LIKE 'character_set'";
 		   if ($rs=$db->Execute($query)) {
      		while ($o1=$rs->FetchNextObject()) {
   			   if (strcmp($o1->VARIABLE_NAME,"character_set")==0 && strcasecmp($o1->VALUE,"greek")!=0) {
   				   echo "<h4>Warning: RDBMS character set not Greek!</h4>\n";
				   }
			   }
			   $rs->Close();
	   	}
		   else {
			   echo "<h4>".$db->ErrorMsg()."</h4>\n";
			}
		}
		else {
         $query="sp_help @objname=varchar";
			if ($rs=$db->Execute($query)) {
      		while ($o1=$rs->FetchNextObject()) {
   			   if ( strncasecmp($o1->COLLATION,"greek",5)!=0 ) {
   				   echo "<h4>Warning: RDBMS character set not Greek!</h4>\n";
				   }
			   }
			   $rs->Close();
	   	}
		   else {
			   echo "<h4>".$db->ErrorMsg()."</h4>\n";
			}
		}
	}

   $how_to_correct="<span style=\"color:black;\">Run <i>Start &gt; Programs &gt;
         iShopping cart &gt; Configuration</i> to correct!</span>";

   @ini_set('variables_order', 'ECGPS');
	$s1=ini_get('variables_order');
   if (strcmp($s1,'ECGPS')!=0) {
      echo "<h4>Warning: variables_order ($s1) error; should be ECGPS!\n$how_to_correct</h4>\n";
   }

	if ((bool)ini_get('magic_quotes_runtime')==true)
	  	echo "<h4>Warning: magic_quotes_runtime should be disabled!\n$how_to_correct</h4>\n";
    
   // modules  
   $ar1=get_loaded_extensions();
   array_walk($ar1, 'array_toLower');
   $required=array('bz2', 'curl', 'gd', 'mbstring', 'mssql', 'mysql', 'sockets');
   
   foreach ($required as $rq1) {
      if (!in_array($rq1,$ar1)) {
         echo "<h4>Warning: extension $rq1 not installed!</h4>\n";
      }
   }
   
   // Examine GD separately
   $f1='gd_info';
   if (!function_exists($f1)) {
      echo "<h4>Function $f1 does not exist!</h4>";
   }
   else {
      $ar1=gd_info();
      do {
         if (!isset($ar1['GD Version'])) {
            echo "<h4>Can not determine gd version!</h4>";
            break;
         }
         $gdv=$ar1['GD Version'];
         $i=strpos($gdv, '.');
         if ($i===false || $i==0) {
            echo "<h4>Can not determine gd version: ${gdv}!</h4>";
            break;
         }
         $major='';
         while (--$i>=0 && ctype_digit($gdv{$i})) {
            $major .= $gdv{$i}; 
         }
         if ($major<2) {
            echo "<h4>Warning: required major version for gd at least2. Got ${major}!</h4>\n";
         }
      } while (false);
   }

   //
   // Notices
   //
 	@include("../pda/ishop_db.php");
 	if (isset($DB_Host))
 		echo "<h5>Notice: Surplus pda/db file!</h5>\n";

	if ((int)ini_get('error_reporting')!=(E_ALL & ~E_NOTICE))
		echo "<h5>Notice: Error reporting should be set to E_ALL &amp; ~E_NOTICE\n$how_to_correct</h5>\n";

	if ((bool)ini_get('magic_quotes_gpc')==true)
		echo "<h5>Notice: magic_quotes_gpc should be disabled!\n$how_to_correct</h5>\n";
      
	echo "</div>&nbsp;";
}
//--------------------------------------
function pr_open_table($labels)
{
	global $x2;

	switch ($x2->xptype)
	{
	case 1:
		echo implode(',',$labels)."\n";
		break;
	case 2:
		echo implode(';',$labels)."\n";
		break;
	case 3:
		echo implode("\t",$labels)."\n";
		break;
	case 5:
		echo implode('#',$labels)."\n";
		break;
	case 4:
	case 100:
		echo "<table><tr>\n";
		$n=count($labels);
	   for ($i=0;$i<$n;$i++) {
         echo "<td>".myhtml($labels[$i])."</td>\n";
      }
      echo "</tr>\n";
		break;
	case 6:
		echo "<script language=\"javascript\">\n".
         "var data=[ [\n";
      $n=count($labels);
	   for ($i=0;$i<$n;$i++) {
         if ($i>0) echo ', ';
         echo "'".addslashes($labels[$i])."'";
      }
      echo "],\n";
		break;
	}
}
//--------------------------------------
function pr_close_table()
{
	global $x2;

	if ($x2->xptype==4)
		echo "</table>\n";
	else if ($x2->xptype==6) {
		// Excel
		?>
		null];
		</script>
		<p></p>
		<table>
		<form>
		<tr>
			<td class=bgLabel>Save to file:</td>
			<td class=bgInput><input type=TEXT name="ASCIIFILE" size=40></td>
		</tr>
		<tr>
			<td class=bgLabel>Output folder</td>
			<td class=bgInput><input type=button value="Locate output folder" onclick="browse_d1(this.form.ASCIIFILE,'Export to Excel (tm)')"></td>
		</tr>
		<tr>
			<td></td>
			<td class=bgButton>
		      <input type=button value="Save" onclick="goSaveXls(this.form)">
		   </td>
		</tr>
		</form>
		</table>
		<?php
   }
}
//--------------------------------------
function remakeRowData(&$row1)
{
	global $x2;

   $n=count($row1);

   switch ($x2->xptype)
	{
	case 1:
	case 2:
	case 3:
	case 5:
		for ($i=0;$i<$n;$i++) {
			$row1[$i]=strip_tags($row1[$i]);
		}
		break;
	case 6: // Excel
		for ($i=0;$i<$n;$i++) {
			$row1[$i]=addslashesEx(strip_tags($row1[$i]));
		}
		break;
   default: // 0, 4
   	// do not modify
		break;
	}
}
//--------------------------------------
function printRowData(&$gr1, $row1)
{
	global $x2;

	switch ($x2->xptype)
   {
	case 0: // on screen
		$gr1->rows[]=$row1;
		break;
	case 1: // Comma separated
		echo implode(',',$row1)."\n";
		break;
	case 2: // Delimiter separated
		echo implode(';',$row1)."\n";
		break;
	case 3: // Tab separated
		echo implode("\t",$row1)."\n";
		break;
	case 4: // Tabular format
	case 100: // Printing
		echo "<tr><td>";
      echo implode("</td><td>",$row1);
      echo "</td></tr>\n";
		break;
	case 5: // Hash (#) separated
		echo implode('#',$row1)."\n";
		break;
	case 6: // Excel (tm) file
		echo "[";
		echo implode(',',$row1);
		echo "],\n";
		break;
	}
}
//--------------------------------------
function addslashesEx($s1)
{
	return "'".addslashes($s1)."'";
}
//--------------------------------------
function fill_exeplace(&$exeplace)
{
	global $x2;
 	$db=&$x2->db;

	$exeplace=array(0=>'0# '.$x2->xlabel('without'), 1=>'1# '.$x2->xlabel('base_pos') );

	$query="SELECT T1.EXEPLACE, T2.MENUDES FROM ishop_exeplace T1
	   LEFT JOIN menurep T2 ON (T2.AGENTID=T1.AGENTID AND T2.MENUTYPE=14 AND T2.MENUID=T1.EXEPLACE)
      WHERE T1.AGENTID=? 
      GROUP BY T1.EXEPLACE, T2.MENUDES
      ORDER BY T1.EXEPLACE";
	$data=array($x2->agentid);
	if (($rs=$db->Execute($query, $data))===false) {
		echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
   while ($o2=$rs->FetchNextObject()) {
      $db->verify_8($o2->EXEPLACE);
      $db->verify_8($o2->MENUDES);
      
      $exeplace[$o2->EXEPLACE]=$o2->EXEPLACE.'# '.$o2->MENUDES;
   }
   $rs->Close();

   return true;
}
//--------------------------------------
function fill_printpos(&$printpos)
{
	global $x2;
 	$db=&$x2->db;

	$printpos=array(0=>'0# '.$x2->xlabel('without') );

	$query="SELECT PRINTPOS, POSNAME FROM ishop_printpos WHERE AGENTID=? ORDER BY PRINTPOS";
	$data=array($x2->agentid);
	if (($rs=$db->Execute($query, $data))===false) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
   while ($o2=$rs->FetchNextObject()) {
      $db->verify_8($o2->PRINTPOS);
      $db->verify_8($o2->POSNAME);
      
      $printpos[$o2->PRINTPOS]=$o2->PRINTPOS.'# '.$o2->POSNAME;
   }
   $rs->Close();

   return true;
}
//--------------------------------------
function fill_reseller(&$reArray)
{
	global $x2;
 	$db=&$x2->db;

	$reArray=array( 0 => $x2->xlabel('without') );

	$query="SELECT RESELID, RE_NAME FROM reseller WHERE AGENTID=? ORDER BY RESELID";
	$data=array($x2->agentid);
   if (($rs=$db->Execute($query, $data))===false) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
	while ($row=$rs->FetchRow()) {
      $db->verify_8($row);
      
      $reArray[ $row[0] ]=$row[0].'# '.$row[1];
   }
   $rs->Close();

   return true;
}
//--------------------------------------
function fill_paygrp(&$paygrp)
{
   global $x2;
 	$db=&$x2->db;
   
   $paygrp=array( 0 => $x2->xlabel('without') );
   
   $query="SELECT MENUID, MENUDES FROM menurep WHERE AGENTID=? AND MENUTYPE=19 ORDER BY MENUID";
	$data=array($x2->agentid);
   if (($rs=$db->Execute($query, $data))===false) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
	while ($row=$rs->FetchRow()) {
      $db->verify_8($row);
      
      $paygrp[ $row[0] ]=$row[0].'# '.$row[1];
   }
   $rs->Close();

   return true;
}
//--------------------------------------
function fill_areas(&$areas)
{
   global $x2;
 	$db=&$x2->db;

	$areas=array( 0 => $x2->xlabel('without') );

	$query="SELECT AREAID, TITLE FROM ishop_area_grp WHERE AGENTID=? ORDER BY AREAID";
	$data=array($x2->agentid);
   if (($rs=$db->Execute($query, $data))===false) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
	while ($row=$rs->FetchRow()) {
      $db->verify_8($row);
      
      $areas[ $row[0] ]=$row[0].'# '.$row[1];
   }
   $rs->Close();

   return true;
}
//--------------------------------------
function fill_ctg(&$ctg)
{
	global $x2;
 	$db=&$x2->db;

   $obj=array();
	$query="SELECT PAGENO,ABBREV FROM ishop_ctg WHERE AGENTID=? ORDER BY PAGENO";
	$data=array($x2->agentid);
	if (($rs=$db->Execute($query,$data))===false) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
   	return false;
 	}
	while ($o2=$rs->FetchNextObject()) {
      $db->verify_8($o2->ABBREV);
		$obj[]=$o2;
	}
	$rs->Close();

	usort ($obj, "ctg_sort");

	$ctg=array( 0=>'0# '.$x2->xxlabel('without') );
	foreach($obj as $o2) {
		$ctg[ $o2->PAGENO ]=$o2->PAGENO.'# '.$o2->ABBREV;
	}

	return true;
}
//--------------------------------------
function copyfrom_smen()
{
   global $x2;
   $db=&$x2->db;

   $query="DELETE FROM reselpref WHERE RESELID=?";
   $data=array( (int)$_REQUEST['RECORDID'] );
   if (!$db->Execute($query,$data)) {
      echo "<h6>".$db->ErrorMsg()."</h6>\n";
      return;
   }

   $rec=array();
   $query="SELECT PNAME, PVALUE FROM reselpref WHERE RESELID=?";
   $data=array( (int)$_REQUEST['COPYFROM'] );
   if (($rs=$db->Execute($query,$data))===false) {
      echo "<h6>".$db->ErrorMsg()."</h6>\n";
      return;
   }
   while ($o1=$rs->FetchNextObject()) {
      $db->verify_8($o2->PVALUE);
      $rec[]=$o1;
   }
   $rs->Close();

   if (($n=count($rec))==0)
      return;

   $t1='reselpref';
   $prim=array('RESELID','PNAME');
   $data=array('RESELID'=>(int)$_REQUEST['RECORDID'], 'PNAME'=>'', 'PVALUE'=>'');
   for ($i=0;$i<$n;$i++) {
      $o1=$rec[$i];
      $data['PNAME']=$o1->PNAME;
      $data['PVALUE']=$o1->PVALUE;
      if (!ReplaceEx($db,$t1,$data,$prim))
         echo "<h6>".$db->ErrorMsg()."</h6>\n";
   }
}
//--------------------------------------
function check_for_tables()
{
   global $x2;
   $db=&$x2->db;
   
   $last_upd=0;
   $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='LAST_TABLE_UPDATE' ";
   if (($rs=$db->Execute($query))===false) {
      echo $db->ErrorMsg();
      return;
   }
   if ($row=$rs->FetchRow()) {
      $last_upd=(int)$row[0];
   }
   $rs->Close();
   
   $f1=DOCUMENT_ROOT."/ishop/ishop_tables.php";
   if (PHP_OS=='WINNT') {
      $f1=strtr($f1, "/", "\\");
   }

   $last_mt=filemtime($f1);
   
   if ($last_mt<=$last_upd) {
      // UP TO DATE
      return;
   }
   
   // Silent check_tables()
	require_once('ishop_tables.php');
	check_tables($db);

   $t1='agent_main';
   $prim=array('AGENTID', 'PNAME');
   $data=array('AGENTID'=>0, 'PNAME'=>'LAST_TABLE_UPDATE', 'PVALUE'=>(string)$last_mt);
   if (!$db->ReplaceEx($t1,$data,$prim))
      echo $db->ErrorMsg();
}
//--------------------------------------
function check_for_messages()
{
   global $x2;
   $db=&$x2->db;
   
   $last_upd=0;
   $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='LAST_MSG_UPDATE' ";
   if (($rs=$db->Execute($query))===false) {
      echo $db->ErrorMsg();
      return;
   }
   if ($row=$rs->FetchRow()) {
      $last_upd=(int)$row[0];
   }
   $rs->Close();
   
   $f1=DOCUMENT_ROOT."/ishop/messages.php";
   if (PHP_OS=='WINNT')
      $f1=strtr($f1, "/", "\\");

   $last_mt=filemtime($f1);
   
   if ($last_mt<=$last_upd) {
      // UP TO DATE
      return;
   }
   
	remake_lex($db);

   $t1='agent_main';
   $prim=array('AGENTID', 'PNAME');
   $data=array('AGENTID'=>0, 'PNAME'=>'LAST_MSG_UPDATE', 'PVALUE'=>(string)$last_mt);
   if (!$db->ReplaceEx($t1,$data,$prim))
      echo $db->ErrorMsg();
}
//--------------------------------------
function ConvertSmsNumber($src)
{
   $outs='';

   // Remove anything other then number
   $str1='0123456789';
   $l=strlen($src);
   for ($i=0;$i<$l;$i++) {
      $c1=$src{$i};
      if (strpos($str1,$c1)!==false)
         $outs .= $c1;
   }
   
   // Remove leading zero
   while (strlen($outs)>0 && $outs{0}=='0') {
      $outs= substr($outs,1);
   }
   
   // If it starts with a 'Mobile Id' prepend with '30'
   if (substr($outs,0,2)=='69')
      $outs='30'.$outs;

   return $outs;
}
//--------------------------------------
function do_delete_detail($icode)
{
   global $x2;

   $doc=$x2->get_detail_name($icode);
   @unlink($doc);
}
//--------------------------------------
function f_remake_contact_abc(&$db, $agentid, $telid)
{
   $err=false;

   $query="DELETE FROM ishop_telfind WHERE AGENTID=? ";
   $data=array($agentid);
   if ($telid!==false) {
      $query .= " AND TELID=?";
      $data[]=$telid;
   }
   if (!$db->Execute($query,$data)) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
		return;
	}

	$qin="INSERT INTO ishop_telfind (TELID, AGENTID, TRKEY) VALUES(?,?,?)";

	$ar2=array('FIRSTNAME', 'LASTNAME', 'TELNR', 'TELTYPE',
         'JOBPOS', 'ADDR1', 'ADDR2', 'CITY', 'STATE', 'ZIP', 'COUNTRY',
		   'FLOOR', 'BELL', 'EMAIL', 'COMMENT', 'MBR_LOGIN', 'COMPANY'	);

   $query="SELECT T1.*, T2.COMPANY FROM ishop_tel T1
      LEFT JOIN ishop_mbr T2 ON (T2.AGENTID=T1.AGENTID AND T2.LOGIN=T1.MBR_LOGIN)
      WHERE T1.AGENTID=? ";
   $data=array($agentid);
   if ($telid!==false) {
      $query .= " AND T1.TELID=?";
      $data[]=$telid;
   }
   if (!($rs=$db->Execute($query,$data))) {
		echo "<h6>".$db->ErrorMsg()."</h6>\n";
		return;
	}
	while ($o1=$rs->FetchNextObject()) {
      $nr2=ConvertSmsNumber($o1->TELNR);
      if ($nr2!=$o1->TELNR) {
         $query2="UPDATE ishop_tel SET TELNR=? WHERE TELID=?";
         $data2=array($nr2, $o1->TELID);
         if (!$db->Execute($query2, $data2))
            echo "<h6>".__LINE__.$db->ErrorMsg()."</h6>\n";

         $o1->TELNR=$nr2;
      }

      $keys=array();
      $ar1=get_object_vars($o1);
      foreach ($ar1 as $k2=>$v2) {
         $s2=trim((string)$v2);
         if (strlen($s2)==0)
            continue;

         $trkey=ToEnglish($s2);
         if (in_array($trkey, $keys))
            continue;

         $data2=array($o1->TELID, $agentid, $trkey );
         if (!$db->Execute($qin,$data2)) {
            echo "<h6>".$db->ErrorMsg()."</h6>\n";
            $err=true;
            break;
         }
         $keys[]=$trkey;
      }
   }
   $rs->Close();

   return (!$err);
}
//--------------------------------------
function acc_parts($acc, $g10str)
{
   $l=strlen($acc);
   if ($l<=2) {
      return array($acc);
   }
   
   $outs=array( substr($acc,0,2) );
   $l2=strlen($g10str);
   $x=2;
   for ($i=0;$i<$l2;$i++) {
      if ($l<=$x)
         break;
         
      $c = $g10str{$i};
      $outs[] = substr($acc, $x, $c);
      $x += $c; 
   }
   return $outs;
}
//--------------------------------------
?>
