<?php
if (PHP_SAPI!=='cli') {
   echo "Command line only!";
   return;
}
chdir(dirname($_SERVER['PHP_SELF']));

include("../lib/ado/adodb.inc.php");
include("../lib/generic.inc.php");
include("../ishop/ishop_all.inc.php");
include("../ishop/ishop.inc.php");
include('../ishop/ishop_sms.inc.php');

$prof=new cPROFILER1();
date_default_timezone_set('Europe/Athens');
$db = &db_open();

do {
   $AllowEmail=false;
   $query="SELECT PVALUE FROM agent_main WHERE AGENTID=0 AND PNAME='TXC_ALLOW_EMAIL' ";
   if (($rs=$db->Execute($query))===false) {
      echo $db->ErrorMsg();
      break;
   }
   if ($row=$rs->FetchRow()) {
      $AllowEmail = (bool)$row[0];
   }
   $rs->Close();
   
   $agents=array();
   $query="SELECT DISTINCT(AGENTID) FROM taxi_log";
   if (($rs=$db->Execute($query))===false) {
      echo $db->ErrorMsg();
      break;
   }
   while ($row=$rs->FetchRow()) {
      $agents[]=$row[0];
   }
   $rs->Close();
   
   foreach ($agents as $ag1) {
      $x2=new cX2($db);
      $x2->agentid=$ag1;
      
      // this must be done after $x2 initialization is fully completed (but only once)
      include_once('../ishop/ishop_tax.inc.php');
   
      $x2->read_agent_main(); 
      eafdss_list($AllowEmail);
   }
   
} while (false);

$db->Close();
echo "Elapsed ".$prof->elapsed();
//--------------------------------------
function eafdss_list($AllowEmail)
{
   global $x2, $LIMITS;
   $db=&$x2->db;
   
   $ar1=explode('/',  strtr($_SERVER['PHP_SELF'], '\\', '/'));
   if (count($ar1)>2) {
      array_pop($ar1);
      array_pop($ar1);
      $ar1[]='lib';
      $newpath=implode('/', $ar1).';../lib';
      set_include_path( $newpath );
   }
   else {
      echo "Can not set inlcude path";
      return;
   }   
   
   require_once('Zend/Mail/Transport/Smtp.php');
   require_once('Zend/Mail.php');
   
   //$config = array('auth' => 'login', 'username' => 'inca@incahellas.com', 'password' => 'anasa1');
   $tr = new Zend_Mail_Transport_Smtp($x2->Agp['SMTPSERVER']); //, $config);
   Zend_Mail::setDefaultTransport($tr);
   Zend_Mail::setDefaultFrom($x2->Agp['EMAILFROM'], 'TaxCenter');
   
   // Reset ZLIMIT (per agent)
   limits_reinit($x2, $LIMITS);
   
   $s11=array();
   $query="SELECT T1.MS11, MAX(T1.LASTUPDATE) LUPD FROM taxi_log T1
      WHERE T1.AGENTID=?  
		GROUP BY T1.MS11 
		ORDER BY T1.MS11";
   $data=array($x2->agentid);
   if (!($rs=$db->Execute($query,$data))) {
		echo __LINE__.$db->ErrosMsg();
		return false;
	}
   while ($o1=$rs->FetchNextObject()) {
      $s11[]=$o1;
   }
   $rs->Close();
   
   $query="SELECT T1.MS11, T1.FIRSTSIGNINZ, T1.LASTZTAKEN, T1.LASTZNR, T1.MDAILY, 
      T1.MLASTHARDST, T1.MLASTAPPST, T1.LASTUPDATE, T2.ENABLED, T2.MACHINETYPE, T2.TXLOCATION FROM taxi_log T1
      LEFT JOIN taxi_eafdss T2 ON (T2.MS11=T1.MS11 AND T2.AGENTID=T1.AGENTID) 
      WHERE T1.AGENTID=? AND T1.MS11=? AND T1.LASTUPDATE>=?";
   foreach ($s11 as $om) {
      $data=array($x2->agentid, ToUtf8($om->MS11), $om->LUPD);
      if (($rs=$db->Execute($query,$data))===false) {
         echo __LINE__.$db->ErrorMsg();
         return false;
      }
      if ($o1=$rs->FetchNextObject()) {
         if ($o1->ENABLED>0) {
            $db->verify_8($o1->TXLOCATION);
         
            $rsx=new cTXCERROR($o1);
            $rsx->Alert($x2, $AllowEmail);
         }
      }
      $rs->Close();
   }
   
   return true;
}
//--------------------------------------
?>